SystemOrganization addCategory: #'CTM-Core'!
SystemOrganization addCategory: #'CTM-Example'!

!MethodReference methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 14:59'!
isReferenceToGeneratedMethod

	^ self compiledMethod isCTMGeneratedMethod! !

Object subclass: #CTMEventListener
	instanceVariableNames: 'methodManagement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

CTMEventListener class
	instanceVariableNames: 'instance'!

CTMEventListener class
	instanceVariableNames: 'instance'!

!CTMEventListener class methodsFor: 'as yet unclassified' stamp: 'mig 12/8/2010 20:35'!
instance

	^ instance ifNil: [ instance := self new ]! !

!CTMEventListener class methodsFor: 'as yet unclassified' stamp: 'mig 1/7/2011 10:37'!
reset

	instance ifNotNil: [instance unregister].
	instance := nil.
! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 21:37'!
event: anEvent

	(anEvent itemKind == #method) ifTrue: [ self methodEvent: anEvent ].! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:20'!
methodEvent: anEvent

	| pragmas method |
	method := self methodManagement prepareMethod: anEvent item from: anEvent oldItem.
	
	pragmas := method pragmas.
	pragmas do: [ :pragma |
		CTMThing allSubclassesDo: [:class | | instance |
			instance := class new.
			(instance matchMethodPragma: pragma) ifTrue: [instance handleMethodEvent: anEvent]]].
	

! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 11:53'!
methodManagement

	^ methodManagement ifNil: [ methodManagement := CTMMethodManagement new]! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:12'!
register

	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:! !

!CTMEventListener methodsFor: 'as yet unclassified' stamp: 'mig 12/9/2010 20:13'!
unregister

	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

Object subclass: #CTMMethodManagement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMMethodManagement methodsFor: 'generated-method-handling' stamp: 'SR 1/7/2011 13:20'!
addGeneratedMethodFor: aCompiledMethod with: aCodeString

	| class method generatedMethods |
	class := aCompiledMethod methodClass.
	method := self addMethodTo: class in: #generated with: aCodeString.
	method ifNil: [ ^ nil ].
	
	"Mark new method as generated method"
	method isCTMGeneratedMethod: true.
	
	"Add new method to generated methods list"
	generatedMethods := aCompiledMethod ctmGeneratedMethodsForThis.
	(generatedMethods contains: [:i | i = method selector]) ifFalse: [generatedMethods add: (method selector)].
	aCompiledMethod ctmGeneratedMethodsForThis: generatedMethods.! !

!CTMMethodManagement methodsFor: 'normal-method-handling' stamp: 'SR 1/7/2011 15:07'!
addMethodTo: aClass in: aCategorySymbol with: aCodeString

	| methodAndNode selector |
	methodAndNode := aClass compile: aCodeString classified: aCategorySymbol notifying: nil trailer: aClass defaultMethodTrailer ifFail: [^nil].
	selector := methodAndNode selector.
	
	(aClass methodDictionary includesKey: selector) ifTrue: [
		(aClass>>selector) isCTMGeneratedMethod ifTrue: [ ^ nil ].
	].

	aClass logMethodSource: aCodeString forMethodWithNode: methodAndNode inCategory: aCategorySymbol withStamp: (Utilities changeStamp) notifying: nil.
	aClass addAndClassifySelector: selector withMethod: methodAndNode method inProtocol: aCategorySymbol notifying: nil.
	^ methodAndNode method! !

!CTMMethodManagement methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:18'!
copyCTMPropertiesFrom: anOldCompiledMethod to: aCompiledMethod
	
	aCompiledMethod isCTMGeneratedMethod: (anOldCompiledMethod isCTMGeneratedMethod).
	aCompiledMethod ctmGeneratedMethodsForThis: (anOldCompiledMethod ctmGeneratedMethodsForThis).! !

!CTMMethodManagement methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 13:17'!
prepareMethod: aCompiledMethod from: anOldCompiledMethod

	"Copy our properties from the old method to the new one"
	anOldCompiledMethod ifNotNil: [self copyCTMPropertiesFrom: anOldCompiledMethod to: aCompiledMethod].
	
	"Cleanup generated methods"
	self removeAllGeneratedMethodsFor: aCompiledMethod.
	^ aCompiledMethod methodClass compiledMethodAt: (aCompiledMethod selector) ifAbsent: [ "The method is not in the method dict, so this was caused by an remove event" aCompiledMethod ]! !

!CTMMethodManagement methodsFor: 'generated-method-handling' stamp: 'SR 1/7/2011 13:16'!
removeAllGeneratedMethodsFor: aCompiledMethod

	| class |
	class := aCompiledMethod methodClass.
	
	aCompiledMethod ctmGeneratedMethodsForThis do: [ :methodSelector |
		(class methodDictionary includesKey: methodSelector) ifTrue: [
			self removeMethod: (class>>methodSelector)]].

	aCompiledMethod ctmGeneratedMethodsForThis: (OrderedCollection new).! !

!CTMMethodManagement methodsFor: 'normal-method-handling' stamp: 'SR 1/7/2011 11:06'!
removeMethod: aCompiledMethod

	| class selector |
	class := aCompiledMethod methodClass.
	selector := aCompiledMethod selector.
	
	self removeAllGeneratedMethodsFor: aCompiledMethod.
	class removeSelector: selector.! !

Object subclass: #CTMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Example'!

!CTMTest methodsFor: 'as yet unclassified' stamp: 'mig 1/7/2011 15:28'!
micha: anArray micha2: aSecondArray micha3: aThirdArray

	<optional: #micha: default: 2 optional: #micha3: default: 3>
	
	anArray inspect.! !

!CTMTest methodsFor: 'as yet unclassified' stamp: 'SR 1/7/2011 15:08'!
shortcut: anArray

	<shortcuts: #short count: 3>
	anArray inspect.! !

Object subclass: #CTMThing
	instanceVariableNames: 'methodManagement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

CTMThing subclass: #CTMOptionalParameterThing
	instanceVariableNames: 'config'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMOptionalParameterThing methodsFor: 'pragma-matching' stamp: 'SR 1/7/2011 13:37'!
config

	^ config ifNil: [ config := Dictionary new].! !

!CTMOptionalParameterThing methodsFor: 'pragma-matching' stamp: 'mig 1/7/2011 14:38'!
matchMethodPragma: aPragma

	(aPragma keyword asString matchesRegex: '^(optional\:default\:)*$') ifTrue: [
		aPragma arguments pairsDo: [:key :value |
			self config at: key put: value].
		^ true].
	
	^ super matchMethodPragma: aPragma! !

!CTMOptionalParameterThing methodsFor: 'method-events' stamp: 'mig 1/7/2011 15:07'!
methodAdded: aMethod in: aClass

	self config keys allCombinationsDo: [:each | | signature difference signatureParts callParts code call |
		difference := aMethod selectorParts difference: each.
		signatureParts := difference collectWithIndex: [ :each2 :index | '{1} t{2}' format: {each2 asString. index asString.}].
		signature := signatureParts inject: '' into: [:subTotal :next | '{1} {2}' format: {subTotal. next.}].
		
		callParts := aMethod selectorParts collect: [:each2 | (self config includesKey: each2)
				ifTrue: ['<1s> <2p>' expandMacrosWith: each2 with: (self config at: each2)]
				ifFalse: ['<1s> t<2p>' expandMacrosWith: each2 with: (difference indexOf: each2)]].
		call := callParts inject: '' into: [:subTotal :next | '<1s> <2s>' expandMacrosWith: subTotal with: next].
		
		code := '<1s><n><n><t>^ self <2s>' expandMacrosWith: signature with: call.
		self methodManagement addGeneratedMethodFor: aMethod with: code.
	].! !

CTMThing subclass: #CTMShortcutsThing
	instanceVariableNames: 'shortcutName shortcutMaxCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CTM-Core'!

!CTMShortcutsThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 21:50'!
matchMethodPragma: aPragma

	(aPragma keyword = #shortcuts:count:) ifTrue: [
		shortcutName := aPragma argumentAt: 1.
		shortcutMaxCount := aPragma argumentAt: 2.
		^ true].
	
	^ super matchMethodPragma: aPragma! !

!CTMShortcutsThing methodsFor: 'method-events' stamp: 'mig 1/7/2011 15:00'!
methodAdded: aMethod in: aClass
	
	| methodName collectionCreation parameterName |
	methodName := ''.
	collectionCreation := ''.
	parameterName := aMethod ast arguments last token value.
	
	1 to: shortcutMaxCount do: [ :i | | code |
		methodName := '<1s> <2s>: <3s><4p> ' expandMacrosWithArguments: {methodName. shortcutName. parameterName. i}.
		collectionCreation := '<1s><2s><3p>. ' expandMacrosWithArguments: {collectionCreation. parameterName. i}.
		
		code := '<1s><n><t>^ self <2s> (OrderedCollection newFrom: {<3s>})' expandMacrosWith: methodName with: aMethod selector with: collectionCreation.
		self methodManagement addGeneratedMethodFor: aMethod with: code.
	].! !

!CTMThing class methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 21:59'!
convertModifiedToAddedRemoved

	^ true! !

!CTMThing methodsFor: 'internal' stamp: 'SR 1/6/2011 21:57'!
handleMethodEvent: anEvent

	| class method |
	method := anEvent item.
	class := anEvent environmentAt: #class.

	anEvent isAdded ifTrue: [ ^ self methodAdded: method in: class ].
	anEvent isModified ifTrue: [ ^ self methodModified: method in: class from: (anEvent oldItem) ].
	anEvent isRemoved ifTrue: [ ^ self methodRemoved: method in: class ].! !

!CTMThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 22:03'!
matchClassPragma: aPragma

	^ false! !

!CTMThing methodsFor: 'pragma-matching' stamp: 'SR 1/6/2011 21:25'!
matchMethodPragma: aPragma

	^ false! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 21:32'!
methodAdded: aMethod in: aClass
! !

!CTMThing methodsFor: 'as yet unclassified' stamp: 'SR 1/6/2011 22:03'!
methodManagement

	^ methodManagement ifNil: [ methodManagement := CTMMethodManagement new].! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 22:00'!
methodModified: aMethod in: aClass from: anOldMethod

	self class convertModifiedToAddedRemoved ifTrue: [
		self methodRemoved: anOldMethod in: aClass.
		self methodAdded: aMethod in: aClass]! !

!CTMThing methodsFor: 'method-events' stamp: 'SR 1/6/2011 21:38'!
methodRemoved: aMethod in: aClass! !

!MCPackage methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 15:00'!
snapshot
	| packageInfo definitions categories |
	packageInfo := self packageInfo.
	definitions := OrderedCollection new.
	categories := packageInfo systemCategories.
	categories isEmpty ifFalse: [ definitions add: (MCOrganizationDefinition categories: categories) ].
	packageInfo methods do: [:ea | ea isReferenceToGeneratedMethod ifFalse: [ definitions add: ea asMethodDefinition]] displayingProgress: 'Snapshotting methods...'.
	(packageInfo respondsTo: #overriddenMethods) ifTrue:
		[packageInfo overriddenMethods
			do: [:ea | definitions add:
					(packageInfo changeRecordForOverriddenMethod: ea) asMethodDefinition]
			displayingProgress: 'Searching for overrides...'].
	packageInfo classes do: [:ea | definitions addAll: ea classDefinitions] displayingProgress: 'Snapshotting classes...'.
	(packageInfo respondsTo: #hasPreamble) ifTrue: [
		packageInfo hasPreamble ifTrue: [definitions add: (MCPreambleDefinition from: packageInfo)].
		packageInfo hasPostscript ifTrue: [definitions add: (MCPostscriptDefinition from: packageInfo)].
		packageInfo hasPreambleOfRemoval ifTrue: [definitions add: (MCRemovalPreambleDefinition from: packageInfo)].
		packageInfo hasPostscriptOfRemoval ifTrue: [definitions add: (MCRemovalPostscriptDefinition from: packageInfo)]]. 
	^ MCSnapshot fromDefinitions: definitions
! !

!SequenceableCollection methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:49'!
allCombinationsDo: aBlock

	1 to: self size do: [:i | self combinations: i atATimeDo: aBlock]! !

!AbstractEvent methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:19'!
oldItem

	^ nil! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 11:00'!
ctmGeneratedMethodsForThis

	^ self propertyValueAt: #cmtGenerated ifAbsent: [OrderedCollection new].! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 11:00'!
ctmGeneratedMethodsForThis: aCollection

	^ self propertyValueAt: #cmtGenerated put: aCollection.! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:05'!
isCTMGeneratedMethod

	^ self propertyValueAt: #ctmGenerated ifAbsent: [false]! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:05'!
isCTMGeneratedMethod: aBoolean

	^ self propertyValueAt: #ctmGenerated put: aBoolean! !

!CompiledMethod methodsFor: '*CTM-Core' stamp: 'SR 1/7/2011 13:56'!
selectorParts

	^ (self selector asString subStrings: ':') collect: [:each | (each,':') asSymbol]! !
